use strict;
use Test::More tests => 4;

use_ok('Make::Naive');

my $set = Make::Naive->new();

my (@run,@target);

$set->rule('foo',sub { push @run, 'foo <- bar' },'bar')
    ->rule('foo1',sub { push @run, 'foo1 <- bar1' },'bar1');
$set->rule('bar',sub { push @run, 'bar <-' });

is_deeply( [$set->ordered_targets], [qw[bar bar1 foo foo1]], 'Proposed order is as expected')
  or diag join "\n", $set->ordered_targets;

$set->apply(sub {push @target, shift});

is_deeply( \@run, [ 'foo <- bar', 'foo1 <- bar1' ], 'Run order is as expected')
  or diag join "\n", @run;
is_deeply( \@target, [ 'bar', 'foo', 'foo1' ], 'Target order is as expected')
  or diag join "\n", @target;

