use strict;
use Test::More tests => 2;

use_ok('Make::Naive');

my $set = Make::Naive->new();

# Source is newer than target:
my %mtime = (
  "t/02-target" => [10, undef],
  "t/02-source" => [20, undef],
);

for (sort keys %mtime) {
  open F, ">", $_
    or die "Couldn't create $_ : $!";
  close F;
  utime $mtime{$_}, $mtime{$_}, $_;
};

my $updated;
$set->rule('t/02-target',sub { $updated = $_[1] },'t/02-source');
$set->apply();

is($updated, "t/02-source", "Younger files force an update");

for (sort keys %mtime) {
  unlink $_
    or warn "Couldn't remove '$_' : $!";
};
